/*
 * Constants
{75B4ADD2-1159-484a-AAC4-75971C8DFD3C}
 *  */
const GMARKS_CONTRACTID = '@mozilla.org/gmarks;1';
const GMARKS_CID = Components.ID('{F443406C-961D-4ecc-BF39-C0E9943C72AE}');
const GMARKS_IID = Components.interfaces.nsIGMarksService;
function nsGMarksService() { 
	dump("started nsGMarks\n");
	this.wrappedJSObject = this;
	this.loadPrefs();
	dump("nsIGMarksService loaded\n");
	this.getBookmarksFeed("onload",false);
}
nsGMarksService.prototype = {
	bookmarkArray: new Array(),
	searchArray: null,
	isSignedIn: false,
	showIcon: true,
	exHttps: false,
	sortBy: 'title',
	qsKey: "",
	qsKeyCode: null,
	_tabGroup: null,
	loadPrefs: function(){
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("gmarks");
                            
		this.showIcon=prefs.getBoolPref('.showFav');
		this.exHttps=prefs.getBoolPref('.excludehttps');
		this.sortBy=prefs.getCharPref('sortby');
		this.qsKey=prefs.getCharPref('.keys.quicksearch.key');
	},
	set tabGroup(bkmks){
		this._tabGroup=bkmks;
		for (var n=0;n<bkmks.length;n++){
			this.updateBookmark(bkmks[n],n==(bkmks.length-1));
			//this.sendUpdateBookmark(bkmks[n]);
		}
		this.doCommand("updateTabGroup");
		dump("setting tabGroup\n");
	},
	//get bookmarkCount() {return bookmarkArray.length;},
	/*
	get value()       { return this.val; },
    set value(newval) { return this.val = newval; },
	 */
	getBookmark: function(index) {return this.bookmarkArray[index];},
	setBookmark: function(index, aBookmark) {this.bookmarkArray[index]=aBookmark;},
	removeBookmark: function(bkmk,refresh){
		var idx=this.isBookmarked(bkmk.url);
		if (idx>=0) this.bookmarkArray.splice(idx,1);
		if (refresh) this.doCommand("quickrefresh");
	},
	updateBookmark: function(bkmk,refresh,idx){
		var d=new Date();
		bkmk.date=d.valueOf()*1000+d.getMilliseconds();
		if (idx==null){
			idx=this.getBookmarkIndex(bkmk);
			if (idx>=0) idx=this.isBookmarked(bkmk.url);
		}
		//dump("idx="+idx+"\n");
		if (idx<0){
			idx=-idx;
			this.bookmarkArray.splice(idx+1,0,bkmk);	
		}
		else if (this.bookmarkArray.length==0 || (idx==0 && this.bookmarkArray[0].url!=bkmk.url)){
			this.bookmarkArray.splice(0,0,bkmk);
		}
		else{
			this.bookmarkArray[idx]=bkmk;
		}
		if (refresh) this.doCommand("quickrefresh");
		if (idx>=-idx)
			return idx;
		else
			return -idx;
	},
	onRemoveBookmark : function(bm,star,refresh) { 
		var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	    var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
	    var topWindowOfType = windowManagerInterface.getMostRecentWindow( "navigator:browser" );
	
	    if (topWindowOfType) {
	        if (bm.url==topWindowOfType.content.location.href){
				star=star?star:"off";
			 	Components.classes["@mozilla.org/observer-service;1"]
		         .getService(Components.interfaces.nsIObserverService)
		         .notifyObservers(null, "star-change", star);
			}
	    }
		this.removeBookmark(bm,refresh);	  
        this.send('dlq='+bm.id,true,bm);
   	},
   	onRenameLabel: function(oldLabel, newLabel,refresh){
    	if (!newLabel || newLabel=="") {this.onRemoveLabel(oldLabel); return;}

		for (i=0; i < this.bookmarkArray.length; i++) 
	        for (j=0; j < this.bookmarkArray[i].labels.length; j++) 
	            if (this.bookmarkArray[i].labels[j] == oldLabel){
	                this.bookmarkArray[i].labels[j] = newLabel; break;
				}

    	this.send('op=modlabel&labels='+encodeURIComponent(oldLabel+','+newLabel),true);
    	if (refresh) this.doCommand("quickrefresh");
    },
    onRemoveLabel: function(label,refresh){
		for (i=0; i < this.bookmarkArray.length; i++) 
	        for (j=0; j < this.bookmarkArray[i].labels.length; j++) 
	            if (this.bookmarkArray[i].labels[j] == label){
	                this.bookmarkArray[i].labels.splice(j,1);
				}
    	this.send('op=modlabel&labels='+encodeURIComponent(label));
    	if (refresh) this.doCommand("quickrefresh");
    },
    addLabelToBookmark: function(bm,label,refresh){
    	if (this.hasLabel(bm.labels,label)) return ;
		bm.labels.push(label);//Add label
		this.updateBookmark(bm,refresh);
    	this.sendUpdateBookmark(bm);
    },
    removeLabelFromBookmark: function(bm,label,refresh){
    	var newLabels=new Array();
    	
    	//this.removeBookmark(bm);
    	for (var i=0;i<bm.labels.length;i++){
    		if (bm.labels[i] != label)
    			newLabels.push(bm.labels[i]);
    	}
    	bm.labels=newLabels;
    	this.updateBookmark(bm,refresh);
    	this.sendUpdateBookmark(bm);
    },
    onRenameBookmark: function(bm,title,refresh){
    	if (title){
			//id, url, title, labels, notes, date, image
    		var old=this.createNewBookmark(bm.id, bm.url, bm.title,bm.labels, bm.notes, bm.date,bm.image);
			this.removeBookmark(old);
			bm.title=title;    		
			this.updateBookmark(bm,refresh);
			this.sendUpdateBookmark(bm);
    	}
    },
	checkSignedCookie: function(){
		var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"]
	                        .getService(Components.interfaces.nsICookieManager);
							
	    var i = cookieManager.enumerator; 
	
	    while (i.hasMoreElements()){
	        var cookie = i.getNext();
	        if (cookie instanceof Components.interfaces.nsICookie){
	            if (cookie.host == ".google.com")
	                if (cookie.name == "SID")
	                { 
                        return true;
	                }
	        }
	    }  
	    return false;
	},
	onSignIn: function(refresh,email,pass) {
		var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
		req.open("POST", 'https://www.google.com/accounts/ServiceLoginAuth', false); 
		req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		var data="ltmpl=wsad&ltmplcache=2&rm=false&Email="+email+"&Passwd="+pass;
		req.setRequestHeader('Content-Length', data.length);
		req.send(data);
		var status = -1;
	    try {status = req.status;}catch(e) {}
	    if(status == 200) {
			this.isSignedIn = this.checkSignedCookie();
	        if (this.isSignedIn && refresh) this.doCommand("RetryLoad");
	    }
	},
	getPassInfo: function(){
		var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"]
	                                .getService(Components.interfaces.nsIPasswordManager);
		// the host name of the password we are looking for
		var queryString = 'chrome://gmarks';
		// ask the password manager for an enumerator:
		var e = passwordManager.enumerator;
		// step through each password in the password manager until we find the one we want:
		while (e.hasMoreElements()) {
		    try {
		        // get an nsIPassword object out of the password manager.
		        // This contains the actual password...
		        var pass = e.getNext().QueryInterface(Components.interfaces.nsIPassword);
		        if (pass.host == queryString) {
		             // found it!
					 //dump("found pass!\n");
		             return pass;
		        }
		    } catch (ex) {//Decrypting Failed
				continue;
		    }
		}
	},
	createNewBookmark: function(aId, aURL, aTitle, aLabels, aNotes, aDate, aImage){//aId, aURL, aTitle, aLabels, aNotes, aDate, aImage
		if (aDate==null){
			var d=new Date();
			aDate=d.valueOf()*1000+d.getMilliseconds();
		}
		if (aLabels && typeof aLabels=="string") aLabels=[aLabels];
		return {
			id: aId, url: aURL, title: aTitle, 
			labels: aLabels?aLabels:new Array(), notes: aNotes?aNotes:"",
			date: aDate, image: aImage
		};
		/*
		toString: function(){
				return 'id='+id +'&url='+url+ '&title='+title+'&labels='+labels+ '&notes='+notes;
		 */
	},
	getBookmarksFeed: function(action, sidebar,start,num){
		dump("GMarks: getBookmarksFeed\n");
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("gmarks");
							
		var invalidlbls=prefs.getCharPref(".invalidlbls");
		var invalid=invalidlbls.split(/,\s*/);
		dump("GMarks invalid labels: "+invalidlbls+"\n");
		var dom;//Bookmark info
	    this.isSignedIn = this.checkSignedCookie();
	    dump("GMarks isSignedIn="+this.isSignedIn+"\n");
		var auto=prefs.getBoolPref(".signin");
		if (auto && !this.isSignedIn){
			var pass=this.getPassInfo();
			if (pass) this.onSignIn(false,pass.user,pass.password);
		}
		start=start?start:0;
		num=num?num:1000;
		//this.bookmarkArray=new Array();
	    if (this.isSignedIn){
	        this.sortBy = prefs.getCharPref("sortby");
	        dump("GMarks sortBy="+this.sortBy+"\n");
	        var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
	         
	        // Asyncronous connection with Google Bookmarks server
	        req.open("GET", "http://www.google.com/bookmarks/lookup?output=xml&sort="+this.sortBy+"&start="+start+"&num="+num, true); 
	        req.send(null);
	        dump("GMarks XML: Connecting... \n");
	        req.onreadystatechange = function(ev){
				//dump("readystate="+req.readyState+"\n");		
	            if(req.readyState == 4) 
	            {
					//dump("ready!\n");
	                var status = -1;
	                try {status = req.status} catch(e) {dump("error getting the status\n");}
					//dump("status="+status+"\n");
	                if(status == 200){
	                    dump("GMarks XML: Connection worked! ("+req.status+")\n")
	                    if (dom = req.responseXML)
	                    {		  
	                       	var items = dom.documentElement.getElementsByTagName('bookmark');	
							if (start==0) nsGMarksService.prototype.bookmarkArray=new Array(items.length);
							dump("GMarks XML Items: "+nsGMarksService.prototype.bookmarkArray.length+"\n");
							var i=0;
							var badApples=0;
		                    for (i = 0; i<items.length; i=i+1) {  
		                    	var auxBookmark
								try{
		                        	auxBookmark = nsGMarksService.prototype.createNewBookmark();//{id: 0, url: null, title: null, labels: new Array(), notes: "", date: 0, image: null};
		                         	auxBookmark.labels = new Array();    
									try{
		                            	auxBookmark.id =    items[i].getElementsByTagName('id')[0].childNodes[0].nodeValue;
									}
									catch(e){
										auxBookmark.id = 0;
										dump("GMarks - id error\n");
									}
									try{
										auxBookmark.url =   items[i].getElementsByTagName('url')[0].childNodes[0].nodeValue;
									}
									catch(e){
										auxBookmark.url = "about:blank";
										dump("GMarks - url error\n");
									}
									try{
										auxBookmark.date =   items[i].getElementsByTagName('timestamp')[0].childNodes[0].nodeValue;
									}
									catch(e){
										auxBookmark.date = 0;
										dump("GMarks - date error\n");
									}
									try{
										var tag=items[i].getElementsByTagName('title'); 	
			                            if (tag.length>0)
											auxBookmark.title = tag[0].childNodes[0].nodeValue;
										else
											auxBookmark.title = auxBookmark.url;
									}
									catch(e){
										auxBookmark.title = auxBookmark.url;
										dump("GMarks - title error\n");
									}
		                            auxBookmark.notes = "";
		                            try{
			                            var auxLabelsArray = items[i].getElementsByTagName('label');
			                            for (var j = 0; j < auxLabelsArray.length; j++){
			                            	
											var validLabel=true;
											for (var k=0;k<invalid.length;k++){
												var lbl=invalid[k];
												if (lbl==auxLabelsArray[j].childNodes[0].nodeValue) {validLabel=false; break}
											}
			                            	if ( validLabel )//this.isValidLabel2(auxLabelsArray[j].childNodes[0].nodeValue,invalidlbls)
			                                   	auxBookmark.labels.push(auxLabelsArray[j].childNodes[0].nodeValue);
			                            }
		                            }
			                        catch(e){
			                        	dump("GMarks - label error\n");
			                        }
									try{
		                           		nsGMarksService.prototype.bookmarkArray[i+start]=auxBookmark;
									}
									catch(e){
										dump("error adding bookmark to the array\n");
									}
								}
								catch(e){
									dump("Error with bookmark\n");
									dump(e+"\n");
									dump("Title: "+auxBookmark.title+"\n");
									dump("URL: "+auxBookmark.url+"\n");
									dump("Labels: "+auxBookmark.labels+"\n");
									dump("ID: "+auxBookmark.id+"\n");
									dump("Date: "+auxBookmark.date+"\n");
									badApples++;
								}
							}
                        }
                        if (badApples>0) dump("GMarks number of bad bookmarks = "+badApples+"\n");
						//dump("GMarks XML Items: "+nsGMarksService.prototype.bookmarkArray.length+"\n");
						//prefs.setCharPref('.labels',nsGMarksService.prototype.getLabels());
						//We don't need to wait for the notes because they will not be shown in the tree display.
						var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                                 .getService(Components.interfaces.nsIConsoleService);
  						consoleService.logStringMessage("GMarks: XML Items=" + items.length+"\nMore: "+(items.length==(num+1)));
						if (items.length==num){
							nsGMarksService.prototype.getBookmarksFeed(action,sidebar,start+1000,num);
						}
						else if (sidebar) nsGMarksService.prototype.doCommand(action);
						//Get the bookmark notes
						//dump("RSS: Connecting... \n");
						dump("http://www.google.com/bookmarks/lookup?output=rss&sort="+nsGMarksService.prototype.sortBy+"&start="+start+"&num="+num+"\n");
                        req.open("GET", "http://www.google.com/bookmarks/lookup?output=rss&sort="+nsGMarksService.prototype.sortBy+"&start="+start+"&num="+num, true); 
						req.send(null);
						dump("GMarks: Rss Connecting\n");
						req.onreadystatechange = function(ev){
							if(req.readyState == 4){
								var status = -1;
								try {status = req.status} catch(e) {}
								if(status == 200){
									dump("GMarks RSS: Connected!\n");
									if (dom = req.responseXML){
										var items=dom.documentElement.getElementsByTagName("item");
										//dump("Rss Items: "+items.length+"\n");
										for (var i=0;i<items.length;i++){		
											if (i<nsGMarksService.prototype.bookmarkArray.length){//In the case that google didn't update intime for the first xml feed, but did for the rss feed(used to happen sometimes)
												try{
													var annNode=new Array();
													try{
														annNode=items[i].getElementsByTagName('bkmk_annotation');
													}
													catch (e) {}
													//dump(annNode);
													if (annNode!=null && annNode.length>0){
														nsGMarksService.prototype.bookmarkArray[i+start].notes=annNode[0].childNodes[0].nodeValue;
														//dump("Title: "+nsGMarksService.prototype.bookmarkArray[i].title+"\n");
														//dump("Notes: "+nsGMarksService.prototype.bookmarkArray[i].notes+"\n");
													} else{
														nsGMarksService.prototype.bookmarkArray[i+start].notes="";
													}

												}
												catch(e){
													dump("Error getting notes for bkmk #"+i+"/"+items.length+"\n");
												}
											}
										}
										if (items.length<num){
											if (sidebar)
												nsGMarksService.prototype.doCommand("updateTreeNotes")
											else
												nsGMarksService.prototype.doCommand(action);
										}
									}
								}

							}
						}	                   
					}
				}
			}   
	 	}else if (sidebar) this.doCommand(action);
	},
	getSiteSearch: function(query, action, sidebar){
		//http://google.com/bookmarks/find?hl=en&start=0&bkmk=1&output=xml&q=query here
	
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("gmarks");
							
		var invalidlbls=prefs.getCharPref(".invalidlbls");
		var invalid=invalidlbls.split(/,\s*/);
		var dom;//Bookmark info
	    this.isSignedIn = this.checkSignedCookie();
		var auto=prefs.getBoolPref(".signin");
		if (auto && !this.isSignedIn){
			var pass=this.getPassInfo();
			if (pass) this.onSignIn(false,pass.user,pass.password);
		}
		
	    if (this.isSignedIn){
	        this.sortBy = prefs.getCharPref("sortby");
	        var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
	         
	        // Asyncronous connection with Google Bookmarks server
	        req.open("GET", "http://google.com/bookmarks/find?start=0&bkmk=1&output=xml&num=10000&q="+query, true); 
	        req.send(null);
	        dump("XML: Connecting... \n");
	        req.onreadystatechange = function(ev){
				//dump("readystate="+req.readyState+"\n");		
	            if(req.readyState == 4) 
	            {
					//dump("ready!\n");
	                var status = -1;
	                try {status = req.status} catch(e) {dump("error getting the status\n");}
					//dump("status="+status+"\n");
	                if(status == 200){
	                    dump("XML: Connection worked! ("+req.status+")\n")
	                    if (dom = req.responseXML)
	                    {		  
	                       	var items = dom.documentElement.getElementsByTagName('bookmark');	
							nsGMarksService.prototype.searchArray=new Array(items.length);
							dump("XML Items: "+nsGMarksService.prototype.searchArray.length+"\n");
							var i=0;
	                        for (i = 0; i<items.length; i=i+1) {  
	                        	var auxBookmark = nsGMarksService.prototype.createNewBookmark();//{id: 0, url: null, title: null, labels: new Array(), notes: "", date: 0, image: null};
	                         	auxBookmark.labels = new Array();    
	
	                            auxBookmark.id =    items[i].getElementsByTagName('id')[0].childNodes[0].nodeValue;
								auxBookmark.url =   items[i].getElementsByTagName('url')[0].childNodes[0].nodeValue;
								auxBookmark.date =   items[i].getElementsByTagName('timestamp')[0].childNodes[0].nodeValue;
								var tag=items[i].getElementsByTagName('title'); 	
	                            if (tag.length>0)
									auxBookmark.title = tag[0].childNodes[0].nodeValue;
								else
									auxBookmark.title = auxBookmark.url;
	                            auxBookmark.notes = "";
	                            var auxLabelsArray = items[i].getElementsByTagName('label');
	                            for (var j = 0; j < auxLabelsArray.length; j++){
	                            	
									var validLabel=true;
									for (var k=0;k<invalid.length;k++){
										var lbl=invalid[k];
										if (lbl==auxLabelsArray[j].childNodes[0].nodeValue) {validLabel=false; break}
									}
	                            	if ( validLabel )//this.isValidLabel2(auxLabelsArray[j].childNodes[0].nodeValue,invalidlbls)
	                                   	auxBookmark.labels.push(auxLabelsArray[j].childNodes[0].nodeValue);
	                            }
								//dump(nsGMarksService.prototype.searchArray.length);
	                           	//nsGMarksService.prototype.searchArray.push(auxBookmark);
	                           	nsGMarksService.prototype.searchArray[i]=auxBookmark;
	                           	//dump("i="+i+"/"+items.length+" "+auxBookmark.title+"\n");
	                           	//i++
	                        }
							dump("XML Items: "+nsGMarksService.prototype.searchArray.length+"\n");
							//prefs.setCharPref('.labels',nsGMarksService.prototype.getLabels());
							//We don't need to wait for the notes because they will not be shown in the tree display.
							if (sidebar) nsGMarksService.prototype.doCommand(action);
							//Get the bookmark notes
							//dump("RSS: Connecting... \n");
							dump("GMarks rss address: http://www.google.com/bookmarks/lookup?output=rss&sort="+nsGMarksService.prototype.sortBy+"&num=10000\n");
	                        req.open("GET", "http://www.google.com/bookmarks/lookup?output=rss&sort="+nsGMarksService.prototype.sortBy+"&num=10000", true); 
							req.send(null);
							req.onreadystatechange = function(ev){
								if(req.readyState == 4){
									var status = -1;
									try {status = req.status} catch(e) {}
									if(status == 200){
										dump("RSS: Connected!\n");
										if (dom = req.responseXML){
											var items=dom.documentElement.getElementsByTagName("item");
											//dump("Rss Items: "+items.length+"\n");
											for (var i=0;i<items.length;i++){		
												if (i<nsGMarksService.prototype.searchArray.length){//In the case that google didn't update intime for the first xml feed, but did for the rss feed(used to happen sometimes)
													var annNode;
													try{
														annNode=items[i].getElementsByTagName('bkmk_annotation');
													}
													catch (e) {}
													//dump(annNode);
													if (annNode[0]!=null){
														nsGMarksService.prototype.searchArray[i].notes=annNode[0].childNodes[0].nodeValue;
													} else{
														nsGMarksService.prototype.searchArray[i].notes="";
													}
												}
											}
											if (sidebar)
												nsGMarksService.prototype.doCommand("updateTreeNotes")
											else
												nsGMarksService.prototype.doCommand(action);
										}
									}

								}
							}		                   
						}
					}
				}
	        }
	    }else if (sidebar) this.doCommand(action);
	},
	getID : function(bm){
		dump("get id: "+bm.title+"\n");
		var dom;//Bookmark info
    	this.isSignedIn = this.checkSignedCookie();
		if (this.isSignedIn){
	        var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
	         
	        req.open("GET", "http://www.google.com/bookmarks/lookup?output=xml&sort=date&num=1", true); 
	        req.send(null);
	        req.onreadystatechange = function(ev){	
	            if(req.readyState == 4) {
	                var status = -1;
	                try {status = req.status} catch(e) {dump("error getting the status2\n");}
	                if(status == 200){
	                    if (dom = req.responseXML){		  
	                       	var item = dom.documentElement.getElementsByTagName('bookmark')[0];	
							var tmpBkmk={id: 0, url: null, title: null, labels: new Array(), notes: "", date: 0, image: null};//createNewBookmark();
                            tmpBkmk.id =    item.getElementsByTagName('id')[0].childNodes[0].nodeValue;
							tmpBkmk.url =   item.getElementsByTagName('url')[0].childNodes[0].nodeValue;
							tmpBkmk.date =  item.getElementsByTagName('timestamp')[0].childNodes[0].nodeValue;
							tmpBkmk.labels=new Array();
							var tag=item.getElementsByTagName('title'); 	
                            if (tag.length>0)
								tmpBkmk.title = tag[0].childNodes[0].nodeValue;
							else
								tmpBkmk.title = tmpBkmk.url;
							
							var idx=nsGMarksService.prototype.getBookmarkIndex(tmpBkmk);
							if (idx<0){
								idx=-idx;
								nsGMarksService.prototype.bookmarkArray.splice(idx+1,0,tmpBkmk);	
							}
							else{
								nsGMarksService.prototype.bookmarkArray[idx].id=tmpBkmk.id;;
							}
							dump("id gotten!");
							nsGMarksService.prototype.doCommand("quickrefresh");
                        }
					}
					else
						dump("error getting the new id");
				}
			}
		}
	},
	connectionError: function(bm){
		dump("connection error\n");
		if (bm!=null)
			this.doCommand("connectionerror",bm.url+"|"+bm.title);
	},
	send: function(data,async,bm){
		async=async!=null?async:true;
		var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
    	req.open("POST", 'http://www.google.com/bookmarks/mark', async); 
		req.send(data);
		dump("Send Data: "+data+"\n");
		dump("Async: "+async+"\n");
		req.onreadystatechange = function() {
			dump("readystate="+req.readyState+"\n");
			if(req.readyState == 4) {
				var status = -1;
				try {
					status = req.status;
				}
				catch(e) {
					dump("eror getting status aftr sending\n");
					dump("e="+e+"\n");
				}
				dump("status="+status+"\n");
				if(status != 200){
					nsGMarksService.prototype.connectionError(bm);
				}
			}
		}		
	},
	/*
	GBB_onQuickAddBookmark : function(event, title, url, labels, notes) {
    var theUrl = url ? url : window.content.location.href;
		var docTitle = title ? title : window.content.document.title;	
		var labels = labels ? labels : '';	
		var notes = notes ? notes : '';	

  	var req = new XMLHttpRequest();
    req.open("POST", 'http://www.google.com/bookmarks/mark', true); 
	req.send('q='+encodeURIComponent(theUrl)+'&title='+encodeURIComponent(docTitle)+'&labels='+labels+'&annotation='+notes);
	 */
	sendUpdateBookmark: function(bm,async){
		dump("send update bookmark\n");
		//var data='q='+bm.url;
		
		var data='q='+encodeURIComponent(bm.url)+'&title='+encodeURIComponent(bm.title)
			+'&labels='+bm.labels+'&annotation='+bm.notes;
    	this.send(data,async,bm);
    		
    	if (bm.id==0) this.getID(bm);
    	//async=async?async:true;
		/*
		var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
        //var data='q='+encodeURIComponent(bm.url)+'&title='+encodeURIComponent(bm.title)+
    	//	'&labels='+encodeURIComponent(bm.labels.toString())+'&annotation='+encodeURIComponent(bm.notes);
    	req.open("POST", 'http://www.google.com/bookmarks/mark', false); 
		req.send(data);
		dump("Data: "+data+"\n");
		req.onreadystatechange = function(ev) {
			if(req.readyState == 4) {
				var status = -1;
				try {
					status = req.status }
				catch(e) {}
				if (status!=-1){
					dump("status="+req.statusText+"\n");
				}
				if(status != 200){
					dump("connection Error\n");
					//nsGMarksService.prototype.connectionError(bm);
				}
			}
		}*/
    },
    updateMultipleBookmarks: function(bkmks,i){
    	if (i==null){
    		for (var n=0;n<bkmks.length;n++){
    			this.updateBookmark(bkmks[n],n==(bkmks.length-1));
    		}
    		i=0;
    	}
    	if (i<bkmks.length){
	    	var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
	                   .createInstance(Components.interfaces.nsIXMLHttpRequest);
	    	req.open("POST", 'http://www.google.com/bookmarks/mark', true); 
	    	var bm=bkmks[i];
			req.send('q='+encodeURIComponent(bm.url)+'&title='+encodeURIComponent(bm.title)+
    		'&labels='+encodeURIComponent(bm.labels)+'&annotation='+encodeURIComponent(bm.notes));
			req.onreadystatechange = function(ev) {
				if(req.readyState == 4) {
					var status = -1;
					try {
						status = req.status }
					catch(e) {}
					if(status != 200){
						nsGMarksService.prototype.connectionError(bm);
					}
					else
						nsGMarksService.prototype.updateMultipleBookmarks(bkmks,i+1);
				}
			}
    	}
    },
    reverseIt: function(s) {
        var a = s.split("");
        a = a.reverse();
        return a.join("");
    },
    doCommand: function(command,data){
    	 dump("doCommand: gmarks-"+command+"\n");
    	if (command!=null)
	    	Components.classes["@mozilla.org/observer-service;1"]
		         .getService(Components.interfaces.nsIObserverService)
		         .notifyObservers(null, "gmarks-"+command, data);
	   
    },
    QueryInterface: function(iid) {
        if (!iid.equals(Components.interfaces.nsISupports) &&
            !iid.equals(GMARKS_IID))
            throw Components.results.NS_ERROR_NO_INTERFACE;
        return this;
    },
    getBookmarkIndex: function(value, a, startPos,endPos){//Binary Search
    	a=a?a:this.bookmarkArray;
    	//dump("alen="+a.length+'\n');
		startPos=startPos?startPos:0; endPos=endPos?endPos: a.length-1;
		if (this.sortBy=="title")
			return this.getTitleIndex(value,a,startPos,endPos);
		else
			return this.getDateIndex(value,a,startPos,endPos);
	},
	getTitleIndex: function(value,a,startPos,endPos){//Binary Search
		if (startPos==endPos){
			dump("both equal - "+value.title+"|"+startPos);
			if (value.url==a[startPos].url){
				dump("yaaaaaaaaay\n");
				return startPos; 
			}
			else{
				dump("boooooooo\n");
				return -startPos;
			}
		}
		else if (startPos>endPos){
			dump("greater - "+value.title+"|"+startPos+"\n");
			return -startPos;
		}
		else{
			var midPoint=Math.floor(startPos + ((endPos-startPos)/2));
			//dump("val: "+value.url+"  mid: "+a[midPoint].url+"\n");
			if (value.url==a[midPoint].url){
				dump("found match - "+value.title+"|"+midPoint+"\n");
				return midPoint;
			}
			else if (value.title==a[midPoint].title){
				for (var i=midPoint+1;i<a.length;i++){
					if (value.url==a[i].url)
						return i;
					else if (value.title!=a[i].title) break;
				}
				for (var i=midPoint-1;i>0;i--){
					if (value.url==a[i].url)
						return i;
					else if (value.title!=a[i].title) break;
				}
			}
			if (value.title.toLowerCase()<a[midPoint].title.toLowerCase()){
				if(midPoint>0 && value.title.toLowerCase()>a[midPoint-1].title.toLowerCase()) {
					//dump("inbetten > - "+value.title+"|"+midPoint+"\n");
					return -midPoint;
				}
				return this.getTitleIndex(value,a,startPos,midPoint-1);
			}
			else{
				if(midPoint<a.length && value.title.toLowerCase()<a[midPoint+1].title.toLowerCase()) {
					//dump("inbetten < - "+value.title+"|"+midPoint+"\n");
					return -midPoint;
				}
				return this.getTitleIndex(value,a,midPoint+1, endPos);
			}
		}
	},
	getDateIndex: function(value,a,startPos,endPos){//Binary Search
		if (startPos==endPos){
			if (value.url==a[startPos].url){
				return startPos; 
			}
			else{
				return -startPos;
			}
		}
		else if (startPos>endPos){
			return -startPos;
		}
		else{
			var midPoint=Math.floor(startPos + ((endPos-startPos)/2));
			if (value.url==a[midPoint].url){
				return midPoint;
			}
			else{
				if (value.date<a[midPoint].date){
					if(midPoint>0 && value.date>a[midPoint-1].date) {return -midPoint;}
					return this.getDateIndex(value,a,midPoint+1, endPos);
				}
				else{
					if(midPoint<a.length && value.date<a[midPoint+1].date) {return -midPoint;}
					return this.getDateIndex(value,a,startPos,midPoint-1);
				}
			}
		}
	},
	getMatchingBookmarks: function(query){
		var matching=new Array();
		var secondMatching=new Array();
		var url2Matching=new Array();
		var lblsMatching=new Array();
		var notesMatching=new Array();
		var realStart;
		var urlPos=0;
		var pChar;
		query=query.toLowerCase();
		for (var i=0;i<this.bookmarkArray.length;i++){
			var bm=this.bookmarkArray[i];
			if ((realStart=bm.title.toLowerCase().indexOf(query))>-1 && (realStart==0 || bm.title.substring(realStart-1,realStart)==" ")){//(bm.title.substring(0,query.length).toLowerCase()==query){
				if (realStart==0)
					matching.push(bm);
				else
					secondMatching.push(bm);
				//break;
			}
			else if ((urlPos=bm.url.toLowerCase().indexOf(query))==0){
				matching.push(bm);
				//break;
			}
			else if ((realStart=bm.url.indexOf("://"))>-1
					&& bm.url.substring(realStart+3,realStart+3+query.length).toLowerCase()==query){
				matching.push(bm);
				//break;
			}
			else if (urlPos>0 && (pChar-bm.url.substring(urlPos-1,urlPos))=="." || pChar=="/" || pChar=="-" || pChar=="_" || pChar=="+")
				matching.push(bm);
			else if (urlPos>-1)
				url2Matching.push(bm);
			else if (bm.labels.toString().toLowerCase().indexOf(query)>-1){
				lblsMatching.push(bm);
				//break;
			}
			else if (bm.notes.toString().indexOf(query)>-1){
				notesMatching.push(bm);
				//break;
			}
		}
		matching=matching.concat(secondMatching,url2Matching, lblsMatching, notesMatching);
		//matching=matching.concat(lblsMatching);
		//matching=matching.concat(notesMatching);
		return matching;
	},
    getBookmarkById: function(id){
	    var i;
	    for (i=0; i < this.bookmarkArray.length; i++) 
	  	if (this.bookmarkArray[i].id == id)
	        return this.bookmarkArray[i];
	    return false;	
	},	
	getBookmarksByLabel: function(label) {
	    var i, j;
	    var ret = new Array();
	    for (i=0; i < this.bookmarkArray.length; i++) 
	        for (j=0; j < this.bookmarkArray[i].labels.length; j++) 
	            if (this.bookmarkArray[i].labels[j] == label)
	                ret.push(this.bookmarkArray[i]);
					
		if (this.sortBy=="date"){
			//ret.sort(DateComparator);
		}
		
	    return ret;
	},	
	getLabels: function() {
	    var i, j;
	    var ret = new Array();
	    var source=this.bookmarkArray;
		//if (sortBy=="date"){
		//	source.sort(DateComparator);
		//}
		
		for (i=0; i < this.bookmarkArray.length; i++) {
	        for (j=0; j < this.bookmarkArray[i].labels.length; j++) 
	            if (!this.hasLabel(ret,this.bookmarkArray[i].labels[j]))//Every bookmark has some stupid smh^ label                this.bookmarkArray[i].labels[j].indexOf('^') == -1 && 
	                ret.push(this.bookmarkArray[i].labels[j]);
		}
	    if (this.sortBy=="title"){
			//Sort labels alphabetically
	    	ret.sort(function (x, y){ 	
				if (x.toString().toLowerCase() < y.toString().toLowerCase())
					return -1;
				else if (x.toString().toLowerCase() > y.toString().toLowerCase())
					return 1;
				return 0; 
			});
		}
	    return ret;
	},	
	hasLabel: function(ret, label) {
		for (var i=0;i < ret.length; i++){
			if (ret[i] == label)
				return true;
		}
		return false;
	},
	isBookmarked: function(url) {
	    var i;
	    for (i=0; i < this.bookmarkArray.length; i++) 
	        if (this.bookmarkArray[i].url == url)
	            return i;
	            
	    return false;
	},	
	getUnlabeled: function(){
		var ret=new Array();
		for (var i=0; i < this.bookmarkArray.length; i++)
			if (this.bookmarkArray[i].labels.length==0)
				ret.push(this.bookmarkArray[i]);
		
		return ret;
	}
};

var nsGMarksServiceModule = {
    registerSelf: function(compMgr, fileSpec, location, type) {
        compMgr =
compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
        compMgr.registerFactoryLocation(GMARKS_CID,
                                        "GMarks test",
                                        GMARKS_CONTRACTID,
                                        fileSpec,
                                        location,
                                        type);
    },
    getClassObject: function(compMgr, cid, iid) {
        if (!cid.equals(GMARKS_CID))
            throw Components.results.NS_ERROR_NO_INTERFACE;
        if (!iid.equals(Components.interfaces.nsIFactory))
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
        return nsGMarksServiceFactory;   
    },
    canUnload: function(compMgr) { return true; }
};
var nsGMarksServiceFactory = {
    createInstance: function(outer, iid) {
        if (outer != null)
            throw Components.results.NS_ERROR_NO_AGGREGATION;
        if (!iid.equals(GMARKS_IID) &&
            !iid.equals(Components.interfaces.nsISupports))
            throw Components.results.NS_ERROR_INVALID_ARG;
        return new nsGMarksService();
    }
};
function NSGetModule(comMgr, fileSpec) { return nsGMarksServiceModule; }