var searchBox;
var lastKeyPress=0;
var visibleData=new Array();//=getVisibleData();
/*All
 * ---------------
 * 0=Cell Text
 * 1=if 0, container, if 1, same level as container, 2=child of a container
 * 
 * Visible Data
 * ------------
 * 2=Opened or Closed(true or false)
 * 3=Label Pointer
 * 
 * Bookmarks(Child Data
 * ------------
 * 2=id
 * 3=url
 * 4=labels
 * 5=notes
 * 
 * New Class
 * ----------------
 * type
 * title
 * [id,url,labels,notes]
 * [toggled State, Pointer]
 */
var treeView = {  
	//My vars
	rowsOpen: 0,
	//end my vars
  treeBox: null,
  selection: null,
  //rowCount: function()                     { return visibleData.length; },
  get rowCount()                     { return visibleData.length;},
  setTree: function(treeBox)         { this.treeBox = treeBox; },
  getCellText: function(idx, column) {
  	var title=visibleData[idx].title;
	if (showCount && this.isContainer(idx)){
		title+=' ('+visibleData[idx].data.length+')';
	}
	return title;
  },
  isContainer: function(idx)         {
  	if (idx<visibleData.length && idx>=0)
  		 if (visibleData[idx].type==0) return true;
  	return false;
  },
  isContainerOpen: function(idx)     { if (this.isContainer(idx)) return visibleData[idx].open; else return false;},
  isContainerEmpty: function(idx)    { return false; },
  isSeparator: function(idx)         { return false; },
  isSorted: function()               { return false; },
  isEditable: function(idx, column)  { return true; },

  getParentIndex: function(idx) {
  	if (idx>=visibleData.length) return -1;
    if (this.getLevel(idx)==0) return -1;
	var curLevel=this.getLevel(idx);
    for (var t = idx - 1; t >= 0 ; t--) {
      if (this.isContainer(t) && this.getLevel(t)<curLevel) return t;
    }
    return -1;
  },
  getLevel: function(idx) {
    //if (this.isContainer(idx)) return 0;
	if (visibleData[idx].type==0 || visibleData[idx].type==2) return visibleData[idx].level;
    if (visibleData[idx].type==1) return 0; //Containers and bookmarks with no labels
    return 1;
  },
  hasNextSibling: function(idx, after) {
    var thisLevel = this.getLevel(idx);
    for (var t = idx + 1; t < visibleData.length; t++) {
      var nextLevel = this.getLevel(t)
      if (nextLevel == thisLevel) return true;
      else if (nextLevel < thisLevel) return false;
    }
    return false;
  },
  closeContainer: function(idx){
  	this.rowsOpen--;
  	visibleData[idx].open = false;//Not open

  	var thisLevel = this.getLevel(idx);
  	var deletecount = 0;
  	for (var t = idx + 1; t < visibleData.length; t++) {
    	if (this.getLevel(t) > thisLevel) {
			if (visibleData[t].type==0) visibleData[t].open=false;
			deletecount++;
    	}
		else break;
  	}
  	if (deletecount) {
    	visibleData.splice(idx + 1, deletecount);
  	}
  	return deletecount;
  },
  openContainer: function(idx){
  	visibleData[idx].open = true;
  	if (visibleData[idx].level==0) this.rowsOpen++;

	var toinsert = visibleData[idx].data;
	var lvl=visibleData[idx].level+1;
  	for (var i = 0; i < toinsert.length; i++) {
		if (toinsert[i].type==0)
			visibleData.splice(idx + i + 1, 0, toinsert[i]);
		else
    		visibleData.splice(idx + i + 1, 0,  new BookmarkData(2,toinsert[i],lvl));

  	}
  	return toinsert.length;
  },
  toggleOpenState: function(idx) {
    //if (!item[1]) return;
    if (!this.isContainer(idx)) return;

    if (visibleData[idx].open) {
     	 //We close it
      	var deletecount=this.closeContainer(idx);
      	if (deletecount)
      		this.treeBox.rowCountChanged(idx + 1, -deletecount);
    }
    else {
      	var length=this.openContainer(idx);
      	this.treeBox.rowCountChanged(idx + 1, length);
		var lastRow=this.treeBox.getLastVisibleRow();
		if (idx+1+length>lastRow){
			dump("scroll down!\n");
			this.treeBox.scrollByLines((idx+1+length)-lastRow);
		}
    }
    this.selection.select(idx);
  },
  toggleAll: function(){
  	this.treeBox.beginUpdateBatch();	
  	if (this.rowsOpen==0){
  		//Open all rows
  		for (var i=0;i<visibleData.length;i++){
  			if (this.isContainer(i))
  				i+=this.openContainer(i);
  		}
  	}
  	else{
  		//Close all rows
  		for (var i=0;i<visibleData.length;i++){
  			if (this.isContainerOpen(i))
  				this.closeContainer(i);
  		}
  	}
  	this.treeBox.endUpdateBatch();	
  },
  getImageSrc: function(idx, column) {
  	if (this.isContainer(idx) || !GMS.showIcon) return ;
	//dump("img idx="+idx+"\n");
	//dump(visibleData[idx].image+'\n');
	return visibleData[idx].image;
  },
    
  getProgressMode : function(idx,column) {},
  getCellValue: function(idx, column) {},
  cycleHeader: function(col, elem) {},
  selectionChanged: function() {},
  cycleCell: function(idx, column) {},
  performAction: function(action) {},
  performActionOnCell: function(action, index, column) {},
  
  getRowProperties: function(idx, column, prop) {},
  getCellProperties: function(idx, column, prop) {
  	if (GMS.showIcon==true){
	  var aserv=Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
	  prop.AppendElement(aserv.getAtom("showIcon"));
  	}
  },
  getColumnProperties: function(column, element, prop) {},
  
  canDrop : function(idx, orient) {
  	//return !orient; 
  	if (idx<visibleData.length){
  		if (this.isContainer(idx)){
  			if (orient==0)
  				return true;
  		}
  		else
  			return true;
  	}
  	return false;
  },
  drop : function(index, orient) {
  	if ( !treeDrag) return;
  	var dragIndex=document.getElementById("gmarkList").currentIndex;
  	dump("drop-"+index+"|"+orient+"|"+dragIndex+"\n"); 
  	var label;
  	if (this.isContainer(index))
  		label=visibleData[index].fullTitle;
  	else if (visibleData[index].type==2){
  		var parent=this.getParentIndex(index);
  		if (parent != -1)
  			label=visibleData[parent].fullTitle;
  	}
  	//Add Label to Bookmark(s)
  	var bm=new Array();
  	if (this.isContainer(dragIndex))
  		bm=visibleData[dragIndex].data;
  	else
		bm.push(visibleData[dragIndex]);
  		//bm.push(this.getBookmark(dragIndex));
  	if (label==null || label=="") return;

	for (var i=0;i<bm.length;i++){
		GMS.addLabelToBookmark(bm[i],label,i==bm.length-1);
	}

		
  	dump("dragged onto label: "+label+"\n");
  },
  //Custom stuff
  getURL: function(idx){return visibleData[idx].url;},
  getBookmark: function(idx){
  	return visibleData[idx];
	//return new bookmark(visibleData[idx][2],visibleData[idx][3],visibleData[idx][0],visibleData[idx][4],visibleData[idx][5]);
  }
};

function treeInit() {
	dump("initiated\n");
	var tree = document.getElementById("gmarkList");
	tree.view = treeView;
	tree.selType="single";
}

function openIn(where){
	var url;
}

//chrome://browser/content/utilityOverlay.js
function mouseClick(event){
	var tree=document.getElementById("gmarkList");
	var row = {}, col = {}, obj = {};
	tree.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, obj);
	//dump(event.clientX+'\n');
	if (row.value>=0 && row.value<visibleData.length){
		//var sel=row.value>=0 && row.value<visibleData.length ? tree.currentIndex:-1;
		if (obj.value){
			var sel;
			if (obj.value.toString()!='twisty')
				sel=tree.currentIndex;
			else
				sel=row.value;
			//dump('obj.value='+obj.value+'\n');
	  		if (!tree.view.isContainer(sel)){
	  			if (event.button<2){
					//Open
					//dump("isContainer: "+treeView.isContainer(sel)+"\n");
					openBookmark(treeView.getURL(sel),event);
				}
				else{//Right Click Bookmark
					var popup=document.getElementById("gm-bookmarkPopup");
					//tree.setAttribute("context","gm-bookmarkPopup");
					var remLbl=document.getElementById("remLbl");
					if (visibleData[sel].type==2){
						remLbl.setAttribute("disabled","false");}
					else{
						remLbl.setAttribute("disabled","true");}
					popup.showPopup(tree,event.screenX,event.screenY,"context");
				}
			}
			else{
				if (event.button==2){
					popup=document.getElementById("gm-labelPopup");
					popup.showPopup(tree,event.screenX,event.screenY,"context");//tree.setAttribute("context","gm-labelPopup");
				}
				else if (event.button==1)
					openInTabs(event);
			}
	    }
	    else{
	    	//not on the tree
	    	dump("not in the window\n");
	    	tree.setAttribute("context",null);
	    }
	}
}

function keyPress(event){
	var tree=document.getElementById("gmarkList");
	var sel=tree.currentIndex;
	if (sel<0 || sel>visibleData.length) return;
	var container=treeView.isContainer(sel);
	switch (event.keyCode){
		case 13:
			if (!container){
				openBookmark(treeView.getURL(sel),event);
			}
			break;
		case 46:
			if (!container){
				GMS.onRemoveBookmark(visibleData[sel],null,true);
				//GM.onRemoveBookmark(visibleData[sel],true,true);
			}
			else{
				removeLabel(visibleData[sel]);
			}
			break;
	}
	
}

function openBookmark(url,event){
	var bookmarkPrefs=Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).getBranch("extensions.tabmix.");
	var bkmkNewTab;
	try{
		bkmkNewTab=bookmarkPrefs.getBoolPref("opentabfor.bookmarks");
	}
	catch(e){bkmkNewTab=false;}
	if (!bkmkNewTab)
		openUILink(url,event,false,true);
	else{
		if (event.shiftKey==true)
			openUILinkIn(url,"tabshifted");
		else
			openUILinkIn(url,"tab");
	}
}

function openInTabs(event){
	var x,y;
	if (!event){
		var popup=document.getElementById("gm-labelPopup");
		x=popup.boxObject.x;
		y=popup.boxObject.y;
	}
	else{
		x=event.clientX;
		y=event.clientY;
	}		
	
	var tree=document.getElementById("gmarkList");
	var row = {}, col = {}, obj = {};
	tree.treeBoxObject.getCellAt(x, y, row, col, obj);
	var sel=row.value;
	
	var labelArray = new Array();	
	labelArray = visibleData[sel].data;//bookmarkArray.getBookmarksByLabel(label);      
	for (var i = 0; i < labelArray.length; i++)
		openUILinkIn(labelArray[i].url, "tabshifted");
}

function removeLabelFromBookmark(event){
	dump("removeLabelFromBookmark\n");
	var index=pops.getBookmarkIndex();
	var parent=treeView.getParentIndex(index);
	
	var label=visibleData[parent].fullTitle
	dump("stage2\n");
	GMS.removeLabelFromBookmark(visibleData[index],label);
	GM.quickRefresh();
}

function renameLabel(label, newLabel,refresh){
	if (!label)
		label=visibleData[pops.getLabelIndex()];
	newLabel = newLabel ? newLabel : prompt(strbundle.getString("renameLabel"),label.fullTitle);
	if (!newLabel || newLabel=="") return;
	
	var data=label.data;

	for (var i=0;i<data.length;i++){
		dump(data[i].type+"\n");
		if (data[i].type==0){
			if (i==data.length-1 && refresh==null) refresh=true;
			renameLabel(data[i],newLabel+">"+data[i].title,refresh==true);
		}
		else if (data[i].type==null){
			if (refresh==null) refresh=true;
			GMS.onRenameLabel(label.fullTitle,newLabel,refresh==true);
			break;	
		}	
	}
	dump("finished renaming "+label.fullTitle+" to "+newLabel+"\n");
}

function removeLabel(label, refresh){
	if (!label)
		label=visibleData[pops.getLabelIndex()];
	//if (!confirm(strbundle.getString("removeLabel")+" \""+label.fullTitle+"\"?")) return;
	
	var data=label.data;

	for (var i=0;i<data.length;i++){
		if (data[i].type==0){
			if (i==data.length-1 && refresh==null) refresh=true;
			removeLabel(data[i],refresh==true);
		}
		else if (data[i].type==null){
			if (refresh==null) refresh=true;
			GMS.onRemoveLabel(label.fullTitle,refresh);
			break;	
		}	
	}
}

function removeLabelAndBookmarks(label, refresh){
	dump("idx="+pops.getLabelIndex()+"\n");
	if (!label)
		label=visibleData[pops.getLabelIndex()];
	dump("label="+label.title+"\n");
	var data=label.data;

	for (var i=0;i<data.length;i++){
		if (data[i].type==0){
			if (i==data.length-1 && refresh==null) refresh=true;
			removeLabelAndBookmarks(data[i],refresh==true);
		}
		else if (data[i].type==null){
			if (i==data.length-1){
				if (refresh==null) refresh=true;
			}
			else if (refresh==true) refresh=null; 
	    	GMS.onRemoveBookmark(data[i],null,refresh==true);
		}
	}
}

var pops={
	getIndex: function(x,y){
		var row = {}, col = {}, obj = {};
		document.getElementById("gmarkList").treeBoxObject.getCellAt(x, y, row, col, obj);
		
		return row.value;
	},
	getEventIndex:  function(event){
		return this.getIndex(event.clientX,event.clientY);
	},
	getPopupIndex: function(id){
		var popup=document.getElementById(id);
		var x=popup.boxObject.x;
		var y=popup.boxObject.y;
		
		var index=this.getIndex(x,y);
		if (index!=null && index>=0 && index<=visibleData.length)
			index=document.getElementById("gmarkList").currentIndex;
		else
			index=-1;
			
		return index;
	},
	getBookmarkIndex: function(){
		return this.getPopupIndex("gm-bookmarkPopup");
	},
	getLabelIndex: function(){
		return this.getPopupIndex("gm-labelPopup");
	},
	getID: function(){
		return visibleData[this.getBookmarkIndex()].id;
	},
	getURL: function(){
		return visibleData[this.getBookmarkIndex()].url;
	},
	getLabels: function(){//For bookmarks
		return visibleData[this.getBookmarkIndex()].url;
	},
	getNotes: function(){
		return visibleData[this.getIBookmarkndex()].notes;
	},
	getBookmark: function(){
		//(id, url, title, labels, notes, date, image) {
		var vis=visibleData[pops.getBookmarkIndex()];
		var bm=GMS.createNewBookmark(vis.id,vis.url,vis.title,vis.labels,vis.notes)//new bookmark(vis.id,vis.url,vis.title,vis.labels,vis.notes);
		
		return bm;
		//return visibleData[pops.getBookmarkIndex()];
	},
	
	//For...lables....(the containers)...
	getLabel: function(){
		return visibleData[this.getLabelIndex()].fullTitle;
	}
}

function doSearch(){
	var search=searchBox.value.toLowerCase();
	dump('do search-'+search+'\n');
	
	if (search.length==0){
		//Normal view
		treeView.treeBox.beginUpdateBatch();
		visibleData=getVisibleData();
		treeView.treeBox.endUpdateBatch();
	}
	else {
		GMS.getSiteSearch(search,"quickrefresh",true);
	}
	
}

function updateNotes(){
	if (searchBox.value.length==0)
		visibleData=updateChildNotes(visibleData);
	else{
		for (var i=0;i<GMS.searchArray.length;i++){
			visibleData[i].notes=GMS.searchArray[i].notes;
		}
	}
}

function updateChildNotes(vData){
	//dump(vData);
	for (var v=0;v<vData.length;v++){
		//dump("type="+vData[v].type+"|"+vData[v].title+"\n");
		if (vData[v].type > 0 || vData[v].type==null){// && vData[v].url==GMS.bookmarkArray[i].url) {
			var index=GMS.isBookmarked(vData[v].url);
			vData[v].notes=GMS.bookmarkArray[index].notes;	
			//dump(GMS.bookmarkArray[index].notes+"\n");												
		}
		else if (vData[v].type==0)
			vData[v].data=updateChildNotes(vData[v].data);
	}
	return vData;
}

function handleSearchKeypress(event){
	var keycode=event.keyCode;
	dump("keycode="+keycode+'\n');
	dump(GMS.qsKeyCode+"\n");
	dump(GMS.qsKey+"\n");
	/*for (var p in event){
		dump(p+" = "+event[p]+"\n");
	}*/
	if (GMS.qsKeyCode==null){
		var vkName="DOM_"+GMS.qsKey;
		for (var p in event){
			if (p.toString()==vkName){
				GMS.qsKeyCode=event[p];
				break;
			}
			
		}	
	}
	if (keycode==GMS.qsKeyCode)
		closeSearch()
}

function closeSearch(){
	var d=new Date();
	var time=d.valueOf();
	if (time-lastKeyPress<700){
		//window.openDialog("chrome://gmarks/content/quicksearch.xul","","chrome,centerscreen,modal");
		window.openDialog("chrome://gmarks/content/quicksearch.xul","","chrome,modal,top="+((screen.height/2)-100)+
			",left="+(screen.width/2-200));
	}
	else
		lastKeyPress=time;
}